% OV9S.M %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Formaal                                                                        %
%  Script for oving 9 oppgave 2                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
a=-1; b=0.5; d=1; c=0.6;                % Prosessmodellen
W=1;                                    % Vekt"matrise" for maalestoeyen, W=E(w w') 
V=10.0;                                 % Vekt "matrise" for stoeyen,     V=E(v v')  
A=[a,c;0,0]; C=[0;1]; D=[1,0];          % Augmenterte systemmatriser
[l,x]=lqe(A,C,D,V,W);                   % Control system toolbox finksjon
k1=l(1,1);                              % Kalman forsterkning for estimering av x
k2=l(2,1);                              % Kalman forsterkning for estimering av v

at=[a,0,0;k1,a-k1,c;k2,-k2,0];          % Augmenter modell for simulering av
bt=[b;b;0];                             % system og estimator med feks. lsim.
ct=[c;0;0];                          
dt=eye(3);
et=zeros(3,2);

N=1200;                                 % Antall sampler
v=ones(N,1);                            % Simulerer med et sprang i forstyrrelsen 
v(50:600,1)=v(50:600,1)+ones(551,1)*0.1;% Sprang ved sample 50
u=zeros(N,1);                           % Null paadrag, annet alternativ er randn(N,1)
t=0:N-1; t=t'/50;
x0=[0.6;0.6;1.0];                       % Initialverdier, stasjonaerverdier
y=lsim(at,[bt,ct],dt,et,[u,v],t,x0);    %Simulerer

subplot(211), plot(t,[y(:,1),y(:,2)])   % Plotter resultatene
grid
title('x1 og hat(x1): Tilstand og estimert tilstand')
subplot(212), plot(t,[y(:,3),v])
grid
title('v og hat(v): Forstyrrelsen og estimert forstyrrelse')
xlabel('[time (units)]')