function [U,t]=ts4u(u0,du,N,Ns,dt);
% [U,t]=ts4u(u0,du,N,Ns,dt);
% Purpose
% To make the following step time serie.
%
%       U'
%       |
% u0+du |                    |-------------------------- u0 + du
%       |                    |
% u0    ----------------------
%       1                   Ns                          N
%       |
%       0---------------------------------------------------------->t
%                           Ns*dt                       N*dt

if nargin==0;
 u0=2.0; du=0.2; N=2000; Ns=20; dt=0.2;
end
u0=fchan('Signal mean value:',u0);
du=fchan('Signal step change:',du);
N=fchan('Number of samples : ',N);
Ns=fchan('Step change at sample no.:',Ns);
dt=fchan('Sampling time:',dt);
U=ones(N,1)*u0;
[n,m]=size([Ns:N,1]);
U(Ns:N,1)=U(Ns:N,1)+ones(n,1)*du;
t=0:(N-1); t=t'; t=t*0.2; 
